VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CArrayBuilder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''
'
' CArrayBuilder
' Ȩ 2014 ZX Inc.
' 汾 1.2.4
'
'''''''''''''''''''''''''''''
Option Explicit

Private Type ArrayHolder
    Content() As Byte
    Length As Long
End Type

Private Declare Sub RtlMoveMemory Lib "kernel32" (ByVal Dst As Long, ByVal Src As Long, ByVal Size As Long)

Private mvarArray() As ArrayHolder
Private mvarArrayItems As Long
Private mvarTotalSize As Long

Public Function Append(ByRef NewArray() As Byte, Optional ByVal Size As Long = -1) As CArrayBuilder
    Dim NewArray2() As Byte
    If Size = -1 Then Size = UBound(NewArray) + 1
    If Size > 0 Then
        ReDim Preserve mvarArray(mvarArrayItems) As ArrayHolder
        ReDim NewArray2(0 To Size - 1) As Byte
        RtlMoveMemory VarPtr(NewArray2(0)), VarPtr(NewArray(0)), Size
        mvarArray(mvarArrayItems).Content = NewArray2
        mvarArray(mvarArrayItems).Length = Size
        mvarArrayItems = mvarArrayItems + 1
        mvarTotalSize = mvarTotalSize + Size
    End If
    Set Append = Me
End Function

Public Property Get ToArray() As Byte()
Attribute ToArray.VB_UserMemId = 0
    Dim i As Long, Pos As Long
    Dim ReturnArray() As Byte
    If mvarTotalSize = 0 Then
        'ToArray = Empty
        Exit Property
    End If
    ReDim ReturnArray(0 To mvarTotalSize - 1) As Byte
    Pos = 0
    For i = 0 To mvarArrayItems - 1
        RtlMoveMemory VarPtr(ReturnArray(Pos)), VarPtr(mvarArray(i).Content(0)), mvarArray(i).Length
        Pos = Pos + mvarArray(i).Length
    Next i
    ToArray = ReturnArray
End Property

Public Property Get ToString() As String
    ToString = ToArray
End Property

Public Sub Reset()
    mvarArrayItems = 0
    mvarTotalSize = 0
    Erase mvarArray
End Sub

Private Sub Class_Initialize()
    If mvarArrayItems > 0 Then Reset
End Sub

Private Sub Class_Terminate()
    Reset
End Sub

