VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CStringBuilder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''
'
' CStringBuilder
' Ȩ 2009-2015 ZX Inc.
' 汾 1.2.5
'
' The secret to this class is that it uses the join
'     function which is part of the VBA.Strings Class
'''''''''''''''''''''''''''''
Option Explicit

Private Const CP_ACP = 0

'Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpDefaultChar As Long, ByVal lpUsedDefaultChar As Long) As Long

Private mvarStringArray() As String
Private mvarArrayItems As Long

Public Function Append(ByRef NewStr As String) As CStringBuilder
    ReDim Preserve mvarStringArray(mvarArrayItems) As String
    mvarStringArray(mvarArrayItems) = NewStr
    mvarArrayItems = mvarArrayItems + 1
    Set Append = Me
End Function

Public Function AppendLine(Optional ByRef NewStr As String = "") As CStringBuilder
    ReDim Preserve mvarStringArray(mvarArrayItems + 1) As String
    mvarStringArray(mvarArrayItems) = NewStr
    mvarStringArray(mvarArrayItems + 1) = vbCrLf
    mvarArrayItems = mvarArrayItems + 2
    Set AppendLine = Me
End Function

Public Property Get ToAnsiArray(Optional ByVal LCID As Long) As Byte()
    ToAnsiArray = StrConv(ToString, vbFromUnicode, LCID)
End Property

Public Property Get ToAnsiArrayByCP(Optional ByVal CodePage As Long = CP_ACP) As Byte()
    Dim TmpArr() As Byte, tmpStr As String, StrLen As Long, ArrLen As Long
    tmpStr = ToString
    StrLen = Len(tmpStr)
    ArrLen = WideCharToMultiByte(CodePage, 0, StrPtr(tmpStr), StrLen, 0, 0, 0, 0)
    ReDim TmpArr(0 To ArrLen - 1) As Byte
    WideCharToMultiByte CodePage, 0, StrPtr(tmpStr), StrLen, VarPtr(TmpArr(0)), ArrLen, 0, 0
    ToAnsiArrayByCP = TmpArr
End Property

Public Property Get ToArray() As Byte()
    ToArray = ToString
End Property

Public Property Get ToString() As String
Attribute ToString.VB_UserMemId = 0
    If mvarArrayItems > 0 Then ToString = Join(mvarStringArray, "") Else ToString = ""
End Property

Public Sub Reset()
    mvarArrayItems = 0
    Erase mvarStringArray
End Sub

Private Sub Class_Initialize()
    If mvarArrayItems > 0 Then Reset
End Sub

Private Sub Class_Terminate()
    Reset
End Sub

